unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    OrigImage: TImage;
    Label2: TLabel;
    DestImage: TImage;
    TrackBar1: TTrackBar;
    Label3: TLabel;
    ValueLbl: TLabel;
    AboutBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure AboutBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

const
    MaxPixelCount   =  32768;

type
    pRGBArray  =  ^TRGBArray;
    TRGBArray  =  ARRAY[0..MaxPixelCount-1] OF TRGBTriple;

function Min(a, b: integer): integer;
function Max(a, b: integer): integer;

implementation

uses about;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  OrigImage.Picture.LoadFromFile('Delphi.bmp');
  DestImage.Picture.LoadFromFile('Delphi.bmp');

  OrigImage.Picture.Bitmap.PixelFormat := pf24bit;
  DestImage.Picture.Bitmap.PixelFormat := pf24bit;

  TrackBar1.Position := 0;
  ValueLbl.Caption := '0';
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
var i, j, value: integer;
    OrigRow, DestRow: pRGBArray;
begin
    // get brightness increment value
  value := TTrackBar(Sender).Position;

  if value <= 0 then ValueLbl.Caption := IntToStr(value)
  else ValueLbl.Caption := Format('+%d', [value]);

    // for each row of pixels
  for i := 0 to OrigImage.Picture.Height - 1 do
  begin
    OrigRow := OrigImage.Picture.Bitmap.ScanLine[i];
    DestRow := DestImage.Picture.Bitmap.ScanLine[i];

      // for each pixel in row
    for j := 0 to OrigImage.Picture.Width - 1 do
    begin
        // add brightness value to pixel's RGB values
      if value > 0 then
      begin
          // RGB values must be less than 256
        DestRow[j].rgbtRed := Min(255, OrigRow[j].rgbtRed + value);
        DestRow[j].rgbtGreen := Min(255, OrigRow[j].rgbtGreen + value);
        DestRow[j].rgbtBlue := Min(255, OrigRow[j].rgbtBlue + value);
      end else begin
          // RGB values must be greater or equal than 0
        DestRow[j].rgbtRed := Max(0, OrigRow[j].rgbtRed + value);
        DestRow[j].rgbtGreen := Max(0, OrigRow[j].rgbtGreen + value);
        DestRow[j].rgbtBlue := Max(0, OrigRow[j].rgbtBlue + value);
      end;
    end;
  end;

  DestImage.Repaint;
end;

function Min(a, b: integer): integer;
begin
  if a < b then result := a
  else result := b;
end;

function Max(a, b: integer): integer;
begin
  if a > b then result := a
  else result := b;
end;

procedure TForm1.AboutBtnClick(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

end.
